LeetCode-Combination Sum

题目:https://oj.leetcode.com/problems/combination-sum/

Given a set of candidate numbers (C) and a target number (T), find all unique combinations in C where the candidate numbers sums to T.

The same repeated number may be chosen from C unlimited number of times.

Note:

  • All numbers (including target) will be positive integers.
  • Elements in a combination (a1a2, … , ak) must be in non-descending order. (ie, a1 ≤ a2 ≤ … ≤ ak).
  • The solution set must not contain duplicate combinations.

For example, given candidate set 2,3,6,7 and target 7
A solution set is: 
[7] 
[2, 2, 3] 

源码:Java版本
算法分析:时间复杂度O(n!),空间复杂度O(n)

public class Solution {
   public List<List<Integer>> combinationSum(int[] candidates,
			int target) {
		if (candidates == null) {
			return null;
		}
		Set<List<Integer>> results = new HashSet<List<Integer>>();
		Stack<Integer> stack = new Stack<Integer>();
		Arrays.sort(candidates);
		DFS(candidates,0, target, stack, results);
		return new ArrayList<List<Integer>>(results);
	}

	@SuppressWarnings("unchecked")
	private void DFS(int[] candidates,int start, int target, Stack<Integer> stack,
			Set<List<Integer>> results) {
		if (target == 0) {
			results.add((Stack<Integer>) (stack.clone()));
		}
		for (int i = start; i < candidates.length; i++) {
			stack.push(candidates[i]);
			if (target - candidates[i] >= 0) {
				DFS(candidates, i,target - candidates[i], stack, results);
			}
			stack.pop();
		}
	}
    
}
代码解释:

 1. 因为要升序,所有先对数组进行排序;

 2. 因为要升序,所以下次遍历的开始位置是当前位置,所以添加了start变量;

 3. 结果要无重复,故先用set收集结果去重。  

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值